catch {TE::UTILS::te_msg TE_BD-0 INFO "This block design tcl-file was generate with Trenz Electronic GmbH Board Part:trenz.biz:tec0850_15eg_1e:part0:1.0, FPGA: xczu15eg-ffvb1156-1-e at 2018-09-13T10:21:06."}
catch {TE::UTILS::te_msg TE_BD-1 INFO "This block design tcl-file was modified by TE-Scripts. Modifications are labelled with comment tag  # #TE_MOD# on the Block-Design tcl-file."}

################################################################
# This is a generated script based on design: zusys
#
# Though there are limitations about the generated script,
# the main purpose of this utility is to make learning
# IP Integrator Tcl commands easier.
################################################################

namespace eval _tcl {
proc get_script_folder {} {
   set script_path [file normalize [info script]]
   set script_folder [file dirname $script_path]
   return $script_folder
}
}
variable script_folder
set script_folder [_tcl::get_script_folder]

################################################################
# Check if script is running in correct Vivado version.
################################################################
set scripts_vivado_version 2018.2
set current_vivado_version [version -short]

if { [string first $scripts_vivado_version $current_vivado_version] == -1 } {
   puts ""
   catch {common::send_msg_id "BD_TCL-109" "ERROR" "This script was generated using Vivado <$scripts_vivado_version> and is being run in <$current_vivado_version> of Vivado. Please run the script in Vivado <$scripts_vivado_version> then open the design in Vivado <$current_vivado_version>. Upgrade the design by running \"Tools => Report => Report IP Status...\", then run write_bd_tcl to create an updated script."}

   return 1
}

################################################################
# START
################################################################

# To test this script, run the following commands from Vivado Tcl console:
# source zusys_script.tcl

# If there is no project opened, this script will create a
# project, but make sure you do not have an existing project
# <./myproj/project_1.xpr> in the current working folder.

set list_projs [get_projects -quiet]
if { $list_projs eq "" } {
   create_project project_1 myproj -part xczu15eg-ffvb1156-1-e
   set_property BOARD_PART trenz.biz:tec0850_15eg_1e:part0:1.0 [current_project]
}


# CHANGE DESIGN NAME HERE
variable design_name
set design_name zusys

# If you do not already have an existing IP Integrator design open,
# you can create a design using the following command:
#    create_bd_design $design_name

# Creating design if needed
set errMsg ""
set nRet 0

set cur_design [current_bd_design -quiet]
set list_cells [get_bd_cells -quiet]

if { ${design_name} eq "" } {
   # USE CASES:
   #    1) Design_name not set

   set errMsg "Please set the variable <design_name> to a non-empty value."
   set nRet 1

} elseif { ${cur_design} ne "" && ${list_cells} eq "" } {
   # USE CASES:
   #    2): Current design opened AND is empty AND names same.
   #    3): Current design opened AND is empty AND names diff; design_name NOT in project.
   #    4): Current design opened AND is empty AND names diff; design_name exists in project.

   if { $cur_design ne $design_name } {
      common::send_msg_id "BD_TCL-001" "INFO" "Changing value of <design_name> from <$design_name> to <$cur_design> since current design is empty."
      set design_name [get_property NAME $cur_design]
   }
   common::send_msg_id "BD_TCL-002" "INFO" "Constructing design in IPI design <$cur_design>..."

} elseif { ${cur_design} ne "" && $list_cells ne "" && $cur_design eq $design_name } {
   # USE CASES:
   #    5) Current design opened AND has components AND same names.

   set errMsg "Design <$design_name> already exists in your project, please set the variable <design_name> to another value."
   set nRet 1
} elseif { [get_files -quiet ${design_name}.bd] ne "" } {
   # USE CASES: 
   #    6) Current opened design, has components, but diff names, design_name exists in project.
   #    7) No opened design, design_name exists in project.

   set errMsg "Design <$design_name> already exists in your project, please set the variable <design_name> to another value."
   set nRet 2

} else {
   # USE CASES:
   #    8) No opened design, design_name not in project.
   #    9) Current opened design, has components, but diff names, design_name not in project.

   common::send_msg_id "BD_TCL-003" "INFO" "Currently there is no design <$design_name> in project, so creating one..."

   create_bd_design $design_name

   common::send_msg_id "BD_TCL-004" "INFO" "Making design <$design_name> as current_bd_design."
   current_bd_design $design_name

}

common::send_msg_id "BD_TCL-005" "INFO" "Currently the variable <design_name> is equal to \"$design_name\"."

if { $nRet != 0 } {
   catch {common::send_msg_id "BD_TCL-114" "ERROR" $errMsg}
   return $nRet
}

set bCheckIPsPassed 1
##################################################################
# CHECK IPs
##################################################################
set bCheckIPs 1
if { $bCheckIPs == 1 } {
   set list_check_ips "\ 
xilinx.com:ip:axis_data_fifo:1.1\
trenz.biz:user:ft601_if:1.0\
trenz.biz:user:labtools_fmeter:1.0\
xilinx.com:ip:proc_sys_reset:5.0\
xilinx.com:ip:util_ds_buf:2.1\
xilinx.com:ip:vio:3.0\
xilinx.com:ip:xlconcat:2.1\
xilinx.com:ip:zynq_ultra_ps_e:3.2\
xilinx.com:ip:aurora_64b66b:11.2\
"

   set list_ips_missing ""
   common::send_msg_id "BD_TCL-006" "INFO" "Checking if the following IPs exist in the project's IP catalog: $list_check_ips ."

   foreach ip_vlnv $list_check_ips {
      set ip_obj [get_ipdefs -all $ip_vlnv]
      if { $ip_obj eq "" } {
         lappend list_ips_missing $ip_vlnv
      }
   }

   if { $list_ips_missing ne "" } {
      catch {common::send_msg_id "BD_TCL-115" "ERROR" "The following IPs are not found in the IP Catalog:\n  $list_ips_missing\n\nResolution: Please add the repository containing the IP(s) to the project." }
      set bCheckIPsPassed 0
   }

}

if { $bCheckIPsPassed != 1 } {
  common::send_msg_id "BD_TCL-1003" "WARNING" "Will not continue with creation of design due to the error(s) above."
  return 3
}

##################################################################
# DESIGN PROCs
##################################################################


# Hierarchical cell: GT_system
proc create_hier_cell_GT_system { parentCell nameHier } {

  variable script_folder

  if { $parentCell eq "" || $nameHier eq "" } {
     catch {common::send_msg_id "BD_TCL-102" "ERROR" "create_hier_cell_GT_system() - Empty argument(s)!"}
     return
  }

  # Get object for parentCell
  set parentObj [get_bd_cells $parentCell]
  if { $parentObj == "" } {
     catch {common::send_msg_id "BD_TCL-100" "ERROR" "Unable to find parent cell <$parentCell>!"}
     return
  }

  # Make sure parentObj is hier blk
  set parentType [get_property TYPE $parentObj]
  if { $parentType ne "hier" } {
     catch {common::send_msg_id "BD_TCL-101" "ERROR" "Parent <$parentObj> has TYPE = <$parentType>. Expected to be <hier>."}
     return
  }

  # Save current instance; Restore later
  set oldCurInst [current_bd_instance .]

  # Set parent object as current
  current_bd_instance $parentObj

  # Create cell and set as current instance
  set hier_obj [create_bd_cell -type hier $nameHier]
  current_bd_instance $hier_obj

  # Create interface pins
  create_bd_intf_pin -mode Slave -vlnv xilinx.com:interface:diff_clock_rtl:1.0 GT_DIFF_REFCLK1
  create_bd_intf_pin -mode Slave -vlnv xilinx.com:interface:diff_clock_rtl:1.0 GT_DIFF_REFCLK2
  create_bd_intf_pin -mode Slave -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_RX_rtl:1.0 GT_PE3_RX
  create_bd_intf_pin -mode Master -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_TX_rtl:1.0 GT_PE3_TX
  create_bd_intf_pin -mode Slave -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_RX_rtl:1.0 GT_PE4_RX
  create_bd_intf_pin -mode Master -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_TX_rtl:1.0 GT_PE4_TX
  create_bd_intf_pin -mode Slave -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_RX_rtl:1.0 GT_PE5_RX
  create_bd_intf_pin -mode Master -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_TX_rtl:1.0 GT_PE5_TX
  create_bd_intf_pin -mode Slave -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_RX_rtl:1.0 GT_PE6_RX
  create_bd_intf_pin -mode Master -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_TX_rtl:1.0 GT_PE6_TX
  create_bd_intf_pin -mode Slave -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_RX_rtl:1.0 GT_PE7_RX
  create_bd_intf_pin -mode Master -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_TX_rtl:1.0 GT_PE7_TX
  create_bd_intf_pin -mode Slave -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_RX_rtl:1.0 GT_PE8_RX
  create_bd_intf_pin -mode Master -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_TX_rtl:1.0 GT_PE8_TX

  # Create pins
  create_bd_pin -dir O -from 5 -to 0 channel_up
  create_bd_pin -dir O -from 5 -to 0 dout
  create_bd_pin -dir I gt_rxcdrovrden_in
  create_bd_pin -dir I init_clk
  create_bd_pin -dir I -from 2 -to 0 loopback
  create_bd_pin -dir O pe4_usr_clk
  create_bd_pin -dir O pe7_usr_clk
  create_bd_pin -dir I pma_init
  create_bd_pin -dir I power_down
  create_bd_pin -dir I reset_in
  create_bd_pin -dir I reset_pb

  # Create instance: aurora_m_left_0, and set properties
  set aurora_m_left_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:aurora_64b66b:11.2 aurora_m_left_0 ]
  set_property -dict [ list \
   CONFIG.CHANNEL_ENABLE {X0Y8 X0Y9 X0Y10 X0Y11} \
   CONFIG.C_AURORA_LANES {4} \
   CONFIG.C_GT_LOC_2 {2} \
   CONFIG.C_GT_LOC_3 {3} \
   CONFIG.C_GT_LOC_4 {4} \
   CONFIG.C_LINE_RATE {5} \
   CONFIG.C_REFCLK_FREQUENCY {125} \
   CONFIG.C_REFCLK_SOURCE {MGTREFCLK0_of_Quad_X0Y2} \
   CONFIG.C_START_LANE {X0Y8} \
   CONFIG.C_START_QUAD {Quad_X0Y2} \
   CONFIG.C_UCOLUMN_USED {left} \
   CONFIG.SupportLevel {1} \
   CONFIG.drp_mode {Disabled} \
   CONFIG.interface_mode {Streaming} \
 ] $aurora_m_left_0

  # Create instance: aurora_m_right_0, and set properties
  set aurora_m_right_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:aurora_64b66b:11.2 aurora_m_right_0 ]
  set_property -dict [ list \
   CONFIG.CHANNEL_ENABLE {X1Y8 X1Y9 X1Y10 X1Y11} \
   CONFIG.C_AURORA_LANES {4} \
   CONFIG.C_GT_LOC_2 {2} \
   CONFIG.C_GT_LOC_3 {3} \
   CONFIG.C_GT_LOC_4 {4} \
   CONFIG.C_LINE_RATE {5} \
   CONFIG.C_REFCLK_FREQUENCY {125} \
   CONFIG.C_REFCLK_SOURCE {MGTREFCLK0_of_Quad_X1Y2} \
   CONFIG.C_START_LANE {X1Y8} \
   CONFIG.C_START_QUAD {Quad_X1Y2} \
   CONFIG.C_UCOLUMN_USED {right} \
   CONFIG.SINGLEEND_GTREFCLK {false} \
   CONFIG.SupportLevel {1} \
   CONFIG.drp_mode {Disabled} \
   CONFIG.interface_mode {Streaming} \
 ] $aurora_m_right_0

  # Create instance: aurora_s_left_1, and set properties
  set aurora_s_left_1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:aurora_64b66b:11.2 aurora_s_left_1 ]
  set_property -dict [ list \
   CONFIG.CHANNEL_ENABLE {X0Y12 X0Y13 X0Y14 X0Y15} \
   CONFIG.C_AURORA_LANES {4} \
   CONFIG.C_GT_LOC_2 {2} \
   CONFIG.C_GT_LOC_3 {3} \
   CONFIG.C_GT_LOC_4 {4} \
   CONFIG.C_LINE_RATE {5} \
   CONFIG.C_REFCLK_FREQUENCY {125} \
   CONFIG.C_REFCLK_SOURCE {MGTREFCLK0_of_Quad_X0Y3} \
   CONFIG.C_START_LANE {X0Y12} \
   CONFIG.C_START_QUAD {Quad_X0Y3} \
   CONFIG.C_UCOLUMN_USED {left} \
   CONFIG.SINGLEEND_GTREFCLK {true} \
   CONFIG.SupportLevel {1} \
   CONFIG.drp_mode {Disabled} \
   CONFIG.interface_mode {Streaming} \
 ] $aurora_s_left_1

  # Create instance: aurora_s_left_2, and set properties
  set aurora_s_left_2 [ create_bd_cell -type ip -vlnv xilinx.com:ip:aurora_64b66b:11.2 aurora_s_left_2 ]
  set_property -dict [ list \
   CONFIG.CHANNEL_ENABLE {X0Y4 X0Y5 X0Y6 X0Y7} \
   CONFIG.C_AURORA_LANES {4} \
   CONFIG.C_GT_LOC_2 {2} \
   CONFIG.C_GT_LOC_3 {3} \
   CONFIG.C_GT_LOC_4 {4} \
   CONFIG.C_LINE_RATE {5} \
   CONFIG.C_REFCLK_FREQUENCY {125} \
   CONFIG.C_REFCLK_SOURCE {MGTREFCLK0_of_Quad_X0Y1} \
   CONFIG.C_START_LANE {X0Y4} \
   CONFIG.C_START_QUAD {Quad_X0Y1} \
   CONFIG.C_UCOLUMN_USED {left} \
   CONFIG.SINGLEEND_GTREFCLK {true} \
   CONFIG.SupportLevel {1} \
   CONFIG.drp_mode {Disabled} \
   CONFIG.interface_mode {Streaming} \
 ] $aurora_s_left_2

  # Create instance: aurora_s_right_1, and set properties
  set aurora_s_right_1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:aurora_64b66b:11.2 aurora_s_right_1 ]
  set_property -dict [ list \
   CONFIG.CHANNEL_ENABLE {X1Y4 X1Y5 X1Y6 X1Y7} \
   CONFIG.C_AURORA_LANES {4} \
   CONFIG.C_GT_LOC_2 {2} \
   CONFIG.C_GT_LOC_3 {3} \
   CONFIG.C_GT_LOC_4 {4} \
   CONFIG.C_LINE_RATE {5} \
   CONFIG.C_REFCLK_FREQUENCY {125} \
   CONFIG.C_REFCLK_SOURCE {MGTREFCLK0_of_Quad_X1Y1} \
   CONFIG.C_START_LANE {X1Y4} \
   CONFIG.C_START_QUAD {Quad_X1Y1} \
   CONFIG.C_UCOLUMN_USED {right} \
   CONFIG.SINGLEEND_GTREFCLK {true} \
   CONFIG.SupportLevel {1} \
   CONFIG.drp_mode {Disabled} \
   CONFIG.interface_mode {Streaming} \
 ] $aurora_s_right_1

  # Create instance: aurora_s_right_2, and set properties
  set aurora_s_right_2 [ create_bd_cell -type ip -vlnv xilinx.com:ip:aurora_64b66b:11.2 aurora_s_right_2 ]
  set_property -dict [ list \
   CONFIG.CHANNEL_ENABLE {X1Y12 X1Y13 X1Y14 X1Y15} \
   CONFIG.C_AURORA_LANES {4} \
   CONFIG.C_GT_LOC_2 {2} \
   CONFIG.C_GT_LOC_3 {3} \
   CONFIG.C_GT_LOC_4 {4} \
   CONFIG.C_LINE_RATE {5} \
   CONFIG.C_REFCLK_FREQUENCY {125} \
   CONFIG.C_REFCLK_SOURCE {MGTREFCLK0_of_Quad_X1Y3} \
   CONFIG.C_START_LANE {X1Y12} \
   CONFIG.C_START_QUAD {Quad_X1Y3} \
   CONFIG.C_UCOLUMN_USED {right} \
   CONFIG.SINGLEEND_GTREFCLK {true} \
   CONFIG.SupportLevel {1} \
   CONFIG.drp_mode {Disabled} \
   CONFIG.interface_mode {Streaming} \
 ] $aurora_s_right_2

  # Create instance: axis_data_fifo_0, and set properties
  set axis_data_fifo_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:axis_data_fifo:1.1 axis_data_fifo_0 ]

  # Create instance: axis_data_fifo_1, and set properties
  set axis_data_fifo_1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:axis_data_fifo:1.1 axis_data_fifo_1 ]

  # Create instance: axis_data_fifo_2, and set properties
  set axis_data_fifo_2 [ create_bd_cell -type ip -vlnv xilinx.com:ip:axis_data_fifo:1.1 axis_data_fifo_2 ]

  # Create instance: axis_data_fifo_3, and set properties
  set axis_data_fifo_3 [ create_bd_cell -type ip -vlnv xilinx.com:ip:axis_data_fifo:1.1 axis_data_fifo_3 ]

  # Create instance: axis_data_fifo_4, and set properties
  set axis_data_fifo_4 [ create_bd_cell -type ip -vlnv xilinx.com:ip:axis_data_fifo:1.1 axis_data_fifo_4 ]

  # Create instance: axis_data_fifo_5, and set properties
  set axis_data_fifo_5 [ create_bd_cell -type ip -vlnv xilinx.com:ip:axis_data_fifo:1.1 axis_data_fifo_5 ]

  # Create instance: proc_sys_reset_0, and set properties
  set proc_sys_reset_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:proc_sys_reset:5.0 proc_sys_reset_0 ]

  # Create instance: proc_sys_reset_1, and set properties
  set proc_sys_reset_1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:proc_sys_reset:5.0 proc_sys_reset_1 ]

  # Create instance: proc_sys_reset_2, and set properties
  set proc_sys_reset_2 [ create_bd_cell -type ip -vlnv xilinx.com:ip:proc_sys_reset:5.0 proc_sys_reset_2 ]

  # Create instance: proc_sys_reset_3, and set properties
  set proc_sys_reset_3 [ create_bd_cell -type ip -vlnv xilinx.com:ip:proc_sys_reset:5.0 proc_sys_reset_3 ]

  # Create instance: proc_sys_reset_4, and set properties
  set proc_sys_reset_4 [ create_bd_cell -type ip -vlnv xilinx.com:ip:proc_sys_reset:5.0 proc_sys_reset_4 ]

  # Create instance: proc_sys_reset_5, and set properties
  set proc_sys_reset_5 [ create_bd_cell -type ip -vlnv xilinx.com:ip:proc_sys_reset:5.0 proc_sys_reset_5 ]

  # Create instance: xlconcat_0, and set properties
  set xlconcat_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:xlconcat:2.1 xlconcat_0 ]
  set_property -dict [ list \
   CONFIG.NUM_PORTS {6} \
 ] $xlconcat_0

  # Create instance: xlconcat_1, and set properties
  set xlconcat_1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:xlconcat:2.1 xlconcat_1 ]
  set_property -dict [ list \
   CONFIG.NUM_PORTS {6} \
 ] $xlconcat_1

  # Create interface connections
  connect_bd_intf_net -intf_net Conn1 [get_bd_intf_pins GT_DIFF_REFCLK2] [get_bd_intf_pins aurora_m_left_0/GT_DIFF_REFCLK1]
  connect_bd_intf_net -intf_net Conn2 [get_bd_intf_pins GT_PE4_RX] [get_bd_intf_pins aurora_m_left_0/GT_SERIAL_RX]
  connect_bd_intf_net -intf_net Conn3 [get_bd_intf_pins GT_PE4_TX] [get_bd_intf_pins aurora_m_left_0/GT_SERIAL_TX]
  connect_bd_intf_net -intf_net Conn4 [get_bd_intf_pins GT_PE3_RX] [get_bd_intf_pins aurora_s_left_2/GT_SERIAL_RX]
  connect_bd_intf_net -intf_net Conn5 [get_bd_intf_pins GT_PE3_TX] [get_bd_intf_pins aurora_s_left_2/GT_SERIAL_TX]
  connect_bd_intf_net -intf_net Conn6 [get_bd_intf_pins GT_PE5_RX] [get_bd_intf_pins aurora_s_left_1/GT_SERIAL_RX]
  connect_bd_intf_net -intf_net Conn7 [get_bd_intf_pins GT_PE5_TX] [get_bd_intf_pins aurora_s_left_1/GT_SERIAL_TX]
  connect_bd_intf_net -intf_net Conn8 [get_bd_intf_pins GT_PE6_RX] [get_bd_intf_pins aurora_s_right_2/GT_SERIAL_RX]
  connect_bd_intf_net -intf_net Conn9 [get_bd_intf_pins GT_PE6_TX] [get_bd_intf_pins aurora_s_right_2/GT_SERIAL_TX]
  connect_bd_intf_net -intf_net Conn10 [get_bd_intf_pins GT_PE8_RX] [get_bd_intf_pins aurora_s_right_1/GT_SERIAL_RX]
  connect_bd_intf_net -intf_net Conn11 [get_bd_intf_pins GT_PE8_TX] [get_bd_intf_pins aurora_s_right_1/GT_SERIAL_TX]
  connect_bd_intf_net -intf_net Conn12 [get_bd_intf_pins GT_DIFF_REFCLK1] [get_bd_intf_pins aurora_m_right_0/GT_DIFF_REFCLK1]
  connect_bd_intf_net -intf_net Conn13 [get_bd_intf_pins GT_PE7_RX] [get_bd_intf_pins aurora_m_right_0/GT_SERIAL_RX]
  connect_bd_intf_net -intf_net Conn14 [get_bd_intf_pins GT_PE7_TX] [get_bd_intf_pins aurora_m_right_0/GT_SERIAL_TX]
  connect_bd_intf_net -intf_net aurora_m_left_0_USER_DATA_M_AXIS_RX [get_bd_intf_pins aurora_m_left_0/USER_DATA_M_AXIS_RX] [get_bd_intf_pins axis_data_fifo_0/S_AXIS]
  connect_bd_intf_net -intf_net aurora_m_right_0_USER_DATA_M_AXIS_RX [get_bd_intf_pins aurora_m_right_0/USER_DATA_M_AXIS_RX] [get_bd_intf_pins axis_data_fifo_5/S_AXIS]
  connect_bd_intf_net -intf_net aurora_s_left_1_USER_DATA_M_AXIS_RX [get_bd_intf_pins aurora_s_left_1/USER_DATA_M_AXIS_RX] [get_bd_intf_pins axis_data_fifo_2/S_AXIS]
  connect_bd_intf_net -intf_net aurora_s_left_2_USER_DATA_M_AXIS_RX [get_bd_intf_pins aurora_s_left_2/USER_DATA_M_AXIS_RX] [get_bd_intf_pins axis_data_fifo_1/S_AXIS]
  connect_bd_intf_net -intf_net aurora_s_right_1_USER_DATA_M_AXIS_RX [get_bd_intf_pins aurora_s_right_1/USER_DATA_M_AXIS_RX] [get_bd_intf_pins axis_data_fifo_4/S_AXIS]
  connect_bd_intf_net -intf_net aurora_s_right_2_USER_DATA_M_AXIS_RX [get_bd_intf_pins aurora_s_right_2/USER_DATA_M_AXIS_RX] [get_bd_intf_pins axis_data_fifo_3/S_AXIS]
  connect_bd_intf_net -intf_net axis_data_fifo_0_M_AXIS [get_bd_intf_pins aurora_m_left_0/USER_DATA_S_AXIS_TX] [get_bd_intf_pins axis_data_fifo_0/M_AXIS]
  connect_bd_intf_net -intf_net axis_data_fifo_1_M_AXIS [get_bd_intf_pins aurora_s_left_2/USER_DATA_S_AXIS_TX] [get_bd_intf_pins axis_data_fifo_1/M_AXIS]
  connect_bd_intf_net -intf_net axis_data_fifo_2_M_AXIS [get_bd_intf_pins aurora_s_left_1/USER_DATA_S_AXIS_TX] [get_bd_intf_pins axis_data_fifo_2/M_AXIS]
  connect_bd_intf_net -intf_net axis_data_fifo_3_M_AXIS [get_bd_intf_pins aurora_s_right_2/USER_DATA_S_AXIS_TX] [get_bd_intf_pins axis_data_fifo_3/M_AXIS]
  connect_bd_intf_net -intf_net axis_data_fifo_4_M_AXIS [get_bd_intf_pins aurora_s_right_1/USER_DATA_S_AXIS_TX] [get_bd_intf_pins axis_data_fifo_4/M_AXIS]
  connect_bd_intf_net -intf_net axis_data_fifo_5_M_AXIS [get_bd_intf_pins aurora_m_right_0/USER_DATA_S_AXIS_TX] [get_bd_intf_pins axis_data_fifo_5/M_AXIS]

  # Create port connections
  connect_bd_net -net aurora_m_left_0_channel_up [get_bd_pins aurora_m_left_0/channel_up] [get_bd_pins xlconcat_0/In1]
  connect_bd_net -net aurora_m_left_0_gt_pll_lock [get_bd_pins aurora_m_left_0/gt_pll_lock] [get_bd_pins xlconcat_1/In1]
  connect_bd_net -net aurora_m_left_0_gt_refclk1_out [get_bd_pins aurora_m_left_0/gt_refclk1_out] [get_bd_pins aurora_s_left_1/refclk1_in] [get_bd_pins aurora_s_left_2/refclk1_in]
  connect_bd_net -net aurora_m_left_0_user_clk_out [get_bd_pins pe4_usr_clk] [get_bd_pins aurora_m_left_0/user_clk_out] [get_bd_pins axis_data_fifo_0/s_axis_aclk] [get_bd_pins proc_sys_reset_0/slowest_sync_clk]
  connect_bd_net -net aurora_m_right_0_channel_up [get_bd_pins aurora_m_right_0/channel_up] [get_bd_pins xlconcat_0/In4]
  connect_bd_net -net aurora_m_right_0_gt_pll_lock [get_bd_pins aurora_m_right_0/gt_pll_lock] [get_bd_pins xlconcat_1/In4]
  connect_bd_net -net aurora_m_right_0_gt_refclk1_out [get_bd_pins aurora_m_right_0/gt_refclk1_out] [get_bd_pins aurora_s_right_1/refclk1_in] [get_bd_pins aurora_s_right_2/refclk1_in]
  connect_bd_net -net aurora_m_right_0_user_clk_out [get_bd_pins pe7_usr_clk] [get_bd_pins aurora_m_right_0/user_clk_out] [get_bd_pins axis_data_fifo_5/s_axis_aclk] [get_bd_pins proc_sys_reset_5/slowest_sync_clk]
  connect_bd_net -net aurora_s_left_1_channel_up [get_bd_pins aurora_s_left_1/channel_up] [get_bd_pins xlconcat_0/In2]
  connect_bd_net -net aurora_s_left_1_gt_pll_lock [get_bd_pins aurora_s_left_1/gt_pll_lock] [get_bd_pins xlconcat_1/In2]
  connect_bd_net -net aurora_s_left_1_user_clk_out [get_bd_pins aurora_s_left_1/user_clk_out] [get_bd_pins axis_data_fifo_2/s_axis_aclk] [get_bd_pins proc_sys_reset_2/slowest_sync_clk]
  connect_bd_net -net aurora_s_left_2_channel_up [get_bd_pins aurora_s_left_2/channel_up] [get_bd_pins xlconcat_0/In0]
  connect_bd_net -net aurora_s_left_2_gt_pll_lock [get_bd_pins aurora_s_left_2/gt_pll_lock] [get_bd_pins xlconcat_1/In0]
  connect_bd_net -net aurora_s_left_2_user_clk_out [get_bd_pins aurora_s_left_2/user_clk_out] [get_bd_pins axis_data_fifo_1/s_axis_aclk] [get_bd_pins proc_sys_reset_1/slowest_sync_clk]
  connect_bd_net -net aurora_s_right_1_channel_up [get_bd_pins aurora_s_right_1/channel_up] [get_bd_pins xlconcat_0/In5]
  connect_bd_net -net aurora_s_right_1_gt_pll_lock [get_bd_pins aurora_s_right_1/gt_pll_lock] [get_bd_pins xlconcat_1/In5]
  connect_bd_net -net aurora_s_right_1_user_clk_out [get_bd_pins aurora_s_right_1/user_clk_out] [get_bd_pins axis_data_fifo_4/s_axis_aclk] [get_bd_pins proc_sys_reset_4/slowest_sync_clk]
  connect_bd_net -net aurora_s_right_2_channel_up [get_bd_pins aurora_s_right_2/channel_up] [get_bd_pins xlconcat_0/In3]
  connect_bd_net -net aurora_s_right_2_gt_pll_lock [get_bd_pins aurora_s_right_2/gt_pll_lock] [get_bd_pins xlconcat_1/In3]
  connect_bd_net -net aurora_s_right_2_user_clk_out [get_bd_pins aurora_s_right_2/user_clk_out] [get_bd_pins axis_data_fifo_3/s_axis_aclk] [get_bd_pins proc_sys_reset_3/slowest_sync_clk]
  connect_bd_net -net gt_rxcdrovrden_in_1 [get_bd_pins gt_rxcdrovrden_in] [get_bd_pins aurora_m_left_0/gt_rxcdrovrden_in] [get_bd_pins aurora_m_right_0/gt_rxcdrovrden_in] [get_bd_pins aurora_s_left_1/gt_rxcdrovrden_in] [get_bd_pins aurora_s_left_2/gt_rxcdrovrden_in] [get_bd_pins aurora_s_right_1/gt_rxcdrovrden_in] [get_bd_pins aurora_s_right_2/gt_rxcdrovrden_in]
  connect_bd_net -net init_clk_1 [get_bd_pins init_clk] [get_bd_pins aurora_m_left_0/init_clk] [get_bd_pins aurora_m_right_0/init_clk] [get_bd_pins aurora_s_left_1/init_clk] [get_bd_pins aurora_s_left_2/init_clk] [get_bd_pins aurora_s_right_1/init_clk] [get_bd_pins aurora_s_right_2/init_clk]
  connect_bd_net -net loopback_1 [get_bd_pins loopback] [get_bd_pins aurora_m_left_0/loopback] [get_bd_pins aurora_m_right_0/loopback] [get_bd_pins aurora_s_left_1/loopback] [get_bd_pins aurora_s_left_2/loopback] [get_bd_pins aurora_s_right_1/loopback] [get_bd_pins aurora_s_right_2/loopback]
  connect_bd_net -net pma_init_1 [get_bd_pins pma_init] [get_bd_pins aurora_m_left_0/pma_init] [get_bd_pins aurora_m_right_0/pma_init] [get_bd_pins aurora_s_left_1/pma_init] [get_bd_pins aurora_s_left_2/pma_init] [get_bd_pins aurora_s_right_1/pma_init] [get_bd_pins aurora_s_right_2/pma_init]
  connect_bd_net -net power_down_1 [get_bd_pins power_down] [get_bd_pins aurora_m_left_0/power_down] [get_bd_pins aurora_m_right_0/power_down] [get_bd_pins aurora_s_left_1/power_down] [get_bd_pins aurora_s_left_2/power_down] [get_bd_pins aurora_s_right_1/power_down] [get_bd_pins aurora_s_right_2/power_down]
  connect_bd_net -net proc_sys_reset_0_peripheral_aresetn [get_bd_pins axis_data_fifo_0/s_axis_aresetn] [get_bd_pins proc_sys_reset_0/peripheral_aresetn]
  connect_bd_net -net proc_sys_reset_1_peripheral_aresetn [get_bd_pins axis_data_fifo_1/s_axis_aresetn] [get_bd_pins proc_sys_reset_1/peripheral_aresetn]
  connect_bd_net -net proc_sys_reset_2_interconnect_aresetn [get_bd_pins axis_data_fifo_2/s_axis_aresetn] [get_bd_pins proc_sys_reset_2/interconnect_aresetn]
  connect_bd_net -net proc_sys_reset_3_peripheral_aresetn [get_bd_pins axis_data_fifo_3/s_axis_aresetn] [get_bd_pins proc_sys_reset_3/peripheral_aresetn]
  connect_bd_net -net proc_sys_reset_4_interconnect_aresetn [get_bd_pins axis_data_fifo_4/s_axis_aresetn] [get_bd_pins proc_sys_reset_4/interconnect_aresetn]
  connect_bd_net -net proc_sys_reset_5_peripheral_aresetn [get_bd_pins axis_data_fifo_5/s_axis_aresetn] [get_bd_pins proc_sys_reset_5/peripheral_aresetn]
  connect_bd_net -net reset_in_1 [get_bd_pins reset_in] [get_bd_pins proc_sys_reset_0/ext_reset_in] [get_bd_pins proc_sys_reset_1/ext_reset_in] [get_bd_pins proc_sys_reset_2/ext_reset_in] [get_bd_pins proc_sys_reset_3/ext_reset_in] [get_bd_pins proc_sys_reset_4/ext_reset_in] [get_bd_pins proc_sys_reset_5/ext_reset_in]
  connect_bd_net -net reset_pb_1 [get_bd_pins reset_pb] [get_bd_pins aurora_m_left_0/reset_pb] [get_bd_pins aurora_m_right_0/reset_pb] [get_bd_pins aurora_s_left_1/reset_pb] [get_bd_pins aurora_s_left_2/reset_pb] [get_bd_pins aurora_s_right_1/reset_pb] [get_bd_pins aurora_s_right_2/reset_pb]
  connect_bd_net -net xlconcat_0_dout [get_bd_pins channel_up] [get_bd_pins xlconcat_0/dout]
  connect_bd_net -net xlconcat_1_dout [get_bd_pins dout] [get_bd_pins xlconcat_1/dout]

  # Restore current instance
  current_bd_instance $oldCurInst
}


# Procedure to create entire design; Provide argument to make
# procedure reusable. If parentCell is "", will use root.
proc create_root_design { parentCell } {

  variable script_folder
  variable design_name

  if { $parentCell eq "" } {
     set parentCell [get_bd_cells /]
  }

  # Get object for parentCell
  set parentObj [get_bd_cells $parentCell]
  if { $parentObj == "" } {
     catch {common::send_msg_id "BD_TCL-100" "ERROR" "Unable to find parent cell <$parentCell>!"}
     return
  }

  # Make sure parentObj is hier blk
  set parentType [get_property TYPE $parentObj]
  if { $parentType ne "hier" } {
     catch {common::send_msg_id "BD_TCL-101" "ERROR" "Parent <$parentObj> has TYPE = <$parentType>. Expected to be <hier>."}
     return
  }

  # Save current instance; Restore later
  set oldCurInst [current_bd_instance .]

  # Set parent object as current
  current_bd_instance $parentObj


  # Create interface ports
  set CLK1 [ create_bd_intf_port -mode Slave -vlnv xilinx.com:interface:diff_clock_rtl:1.0 CLK1 ]
  set_property -dict [ list \
   CONFIG.FREQ_HZ {125000000} \
   ] $CLK1
  set CLK2 [ create_bd_intf_port -mode Slave -vlnv xilinx.com:interface:diff_clock_rtl:1.0 CLK2 ]
  set CLK4 [ create_bd_intf_port -mode Slave -vlnv xilinx.com:interface:diff_clock_rtl:1.0 CLK4 ]
  set_property -dict [ list \
   CONFIG.FREQ_HZ {125000000} \
   ] $CLK4
  set GT_PE3_RX [ create_bd_intf_port -mode Slave -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_RX_rtl:1.0 GT_PE3_RX ]
  set GT_PE3_TX [ create_bd_intf_port -mode Master -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_TX_rtl:1.0 GT_PE3_TX ]
  set GT_PE4_RX [ create_bd_intf_port -mode Slave -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_RX_rtl:1.0 GT_PE4_RX ]
  set GT_PE4_TX [ create_bd_intf_port -mode Master -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_TX_rtl:1.0 GT_PE4_TX ]
  set GT_PE5_RX [ create_bd_intf_port -mode Slave -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_RX_rtl:1.0 GT_PE5_RX ]
  set GT_PE5_TX [ create_bd_intf_port -mode Master -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_TX_rtl:1.0 GT_PE5_TX ]
  set GT_PE6_RX [ create_bd_intf_port -mode Slave -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_RX_rtl:1.0 GT_PE6_RX ]
  set GT_PE6_TX [ create_bd_intf_port -mode Master -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_TX_rtl:1.0 GT_PE6_TX ]
  set GT_PE7_RX [ create_bd_intf_port -mode Slave -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_RX_rtl:1.0 GT_PE7_RX ]
  set GT_PE7_TX [ create_bd_intf_port -mode Master -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_TX_rtl:1.0 GT_PE7_TX ]
  set GT_PE8_RX [ create_bd_intf_port -mode Slave -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_RX_rtl:1.0 GT_PE8_RX ]
  set GT_PE8_TX [ create_bd_intf_port -mode Master -vlnv xilinx.com:display_aurora:GT_Serial_Transceiver_Pins_TX_rtl:1.0 GT_PE8_TX ]
  set TEST_CLK [ create_bd_intf_port -mode Slave -vlnv xilinx.com:interface:diff_clock_rtl:1.0 TEST_CLK ]

  # Create ports
  set BE [ create_bd_port -dir IO -from 3 -to 0 BE ]
  set DATA [ create_bd_port -dir IO -from 31 -to 0 DATA ]
  set FIFO_CLK [ create_bd_port -dir I FIFO_CLK ]
  set FTDI_RESET_N [ create_bd_port -dir O -type rst FTDI_RESET_N ]
  set LED_FP [ create_bd_port -dir O -from 2 -to 0 LED_FP ]
  set OE_N [ create_bd_port -dir O OE_N ]
  set RD_N [ create_bd_port -dir O RD_N ]
  set RXF_N [ create_bd_port -dir I RXF_N ]
  set SIWU_N [ create_bd_port -dir O SIWU_N ]
  set TXE_N [ create_bd_port -dir I TXE_N ]
  set WAKEUP_N [ create_bd_port -dir O WAKEUP_N ]
  set WR_N [ create_bd_port -dir O WR_N ]

  # Create instance: GT_system
  create_hier_cell_GT_system [current_bd_instance .] GT_system

  # Create instance: axis_data_fifo_0, and set properties
  set axis_data_fifo_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:axis_data_fifo:1.1 axis_data_fifo_0 ]

  # Create instance: ft601_if_0, and set properties
  set ft601_if_0 [ create_bd_cell -type ip -vlnv trenz.biz:user:ft601_if:1.0 ft601_if_0 ]

  # Create instance: labtools_fmeter_0, and set properties
  set labtools_fmeter_0 [ create_bd_cell -type ip -vlnv trenz.biz:user:labtools_fmeter:1.0 labtools_fmeter_0 ]
  set_property -dict [ list \
   CONFIG.C_CHANNELS {5} \
 ] $labtools_fmeter_0

  # Create instance: proc_sys_reset_0, and set properties
  set proc_sys_reset_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:proc_sys_reset:5.0 proc_sys_reset_0 ]

  # Create instance: util_ds_buf_0, and set properties
  set util_ds_buf_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_ds_buf:2.1 util_ds_buf_0 ]
  set_property -dict [ list \
   CONFIG.C_BUF_TYPE {IBUFDS} \
 ] $util_ds_buf_0

  # Create instance: util_ds_buf_1, and set properties
  set util_ds_buf_1 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_ds_buf:2.1 util_ds_buf_1 ]
  set_property -dict [ list \
   CONFIG.C_BUF_TYPE {BUFG} \
 ] $util_ds_buf_1

  # Create instance: util_ds_buf_2, and set properties
  set util_ds_buf_2 [ create_bd_cell -type ip -vlnv xilinx.com:ip:util_ds_buf:2.1 util_ds_buf_2 ]
  set_property -dict [ list \
   CONFIG.C_BUF_TYPE {IBUFDS} \
 ] $util_ds_buf_2

  # Create instance: vio_0, and set properties
  set vio_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:vio:3.0 vio_0 ]
  set_property -dict [ list \
   CONFIG.C_NUM_PROBE_IN {7} \
   CONFIG.C_NUM_PROBE_OUT {6} \
   CONFIG.C_PROBE_OUT1_INIT_VAL {0x2} \
   CONFIG.C_PROBE_OUT1_WIDTH {3} \
   CONFIG.C_PROBE_OUT2_WIDTH {1} \
   CONFIG.C_PROBE_OUT5_WIDTH {3} \
 ] $vio_0

  # Create instance: xlconcat_0, and set properties
  set xlconcat_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:xlconcat:2.1 xlconcat_0 ]
  set_property -dict [ list \
   CONFIG.NUM_PORTS {5} \
 ] $xlconcat_0

  # Create instance: zynq_ultra_ps_e_0, and set properties
  set zynq_ultra_ps_e_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:zynq_ultra_ps_e:3.2 zynq_ultra_ps_e_0 ]
# #TE_MOD#_Add next line#
  apply_bd_automation -rule xilinx.com:bd_rule:zynq_ultra_ps_e -config {apply_board_preset "1" }  [get_bd_cells zynq_ultra_ps_e_0]
# #TE_MOD#_Add next line#
  set tcl_ext [];if { [catch {set tcl_ext [glob -join -dir ${TE::BOARDDEF_PATH}/carrier_extension/ *_preset.tcl]}] } {};foreach carrier_ext $tcl_ext { source  $carrier_ext};
# #TE_MOD#   set_property -dict [ list \
# #TE_MOD#  ] $zynq_ultra_ps_e_0

# #TE_MOD#    CONFIG.SUBPRESET1 {Custom} \
# #TE_MOD#    CONFIG.PSU__USB3_1__PERIPHERAL__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__USB3_1__EMIO__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__USB3_0__PERIPHERAL__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__USB3_0__EMIO__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__USB2_1__EMIO__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__USB2_0__EMIO__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__USB1__PERIPHERAL__IO {MIO 64 .. 75} \
# #TE_MOD#    CONFIG.PSU__USB1__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__USB1_COHERENCY {0} \
# #TE_MOD#    CONFIG.PSU__USB0__PERIPHERAL__IO {MIO 52 .. 63} \
# #TE_MOD#    CONFIG.PSU__USB0__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__USB0_COHERENCY {0} \
# #TE_MOD#    CONFIG.PSU__UART0__PERIPHERAL__IO {MIO 22 .. 23} \
# #TE_MOD#    CONFIG.PSU__UART0__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__UART0__MODEM__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__UART0__BAUD_RATE {115200} \
# #TE_MOD#    CONFIG.PSU__TTC3__WAVEOUT__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__TTC3__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__TTC3__CLOCK__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__TTC2__WAVEOUT__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__TTC2__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__TTC2__CLOCK__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__TTC1__WAVEOUT__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__TTC1__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__TTC1__CLOCK__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__TTC0__WAVEOUT__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__TTC0__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__TTC0__CLOCK__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__SWDT1__RESET__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__SWDT1__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__SWDT1__CLOCK__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__SWDT0__RESET__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__SWDT0__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__SWDT0__CLOCK__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__SD1__SLOT_TYPE {SD 2.0} \
# #TE_MOD#    CONFIG.PSU__SD1__RESET__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__SD1__PERIPHERAL__IO {MIO 46 .. 51} \
# #TE_MOD#    CONFIG.PSU__SD1__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__SD1__GRP_WP__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__SD1__GRP_POW__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__SD1__GRP_CD__IO {MIO 45} \
# #TE_MOD#    CONFIG.PSU__SD1__GRP_CD__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__SD1__DATA_TRANSFER_MODE {4Bit} \
# #TE_MOD#    CONFIG.PSU__SD1_COHERENCY {0} \
# #TE_MOD#    CONFIG.PSU__QSPI__PERIPHERAL__MODE {Dual Parallel} \
# #TE_MOD#    CONFIG.PSU__QSPI__PERIPHERAL__IO {MIO 0 .. 12} \
# #TE_MOD#    CONFIG.PSU__QSPI__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__QSPI__PERIPHERAL__DATA_MODE {x4} \
# #TE_MOD#    CONFIG.PSU__QSPI__GRP_FBCLK__IO {MIO 6} \
# #TE_MOD#    CONFIG.PSU__QSPI__GRP_FBCLK__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__QSPI_COHERENCY {0} \
# #TE_MOD#    CONFIG.PSU__PSS_REF_CLK__FREQMHZ {33.33333} \
# #TE_MOD#    CONFIG.PSU__PROTECTION__SLAVES {LPD;USB3_1_XHCI;FE300000;FE3FFFFF;1|LPD;USB3_1;FF9E0000;FF9EFFFF;1|LPD;USB3_0_XHCI;FE200000;FE2FFFFF;1|LPD;USB3_0;FF9D0000;FF9DFFFF;1|LPD;UART1;FF010000;FF01FFFF;0|LPD;UART0;FF000000;FF00FFFF;1|LPD;TTC3;FF140000;FF14FFFF;1|LPD;TTC2;FF130000;FF13FFFF;1|LPD;TTC1;FF120000;FF12FFFF;1|LPD;TTC0;FF110000;FF11FFFF;1|FPD;SWDT1;FD4D0000;FD4DFFFF;1|LPD;SWDT0;FF150000;FF15FFFF;1|LPD;SPI1;FF050000;FF05FFFF;0|LPD;SPI0;FF040000;FF04FFFF;0|FPD;SMMU_REG;FD5F0000;FD5FFFFF;1|FPD;SMMU;FD800000;FDFFFFFF;1|FPD;SIOU;FD3D0000;FD3DFFFF;1|FPD;SERDES;FD400000;FD47FFFF;1|LPD;SD1;FF170000;FF17FFFF;1|LPD;SD0;FF160000;FF16FFFF;0|FPD;SATA;FD0C0000;FD0CFFFF;0|LPD;RTC;FFA60000;FFA6FFFF;1|LPD;RSA_CORE;FFCE0000;FFCEFFFF;1|LPD;RPU;FF9A0000;FF9AFFFF;1|FPD;RCPU_GIC;F9000000;F900FFFF;1|LPD;R5_TCM_RAM_GLOBAL;FFE00000;FFE3FFFF;1|LPD;R5_1_Instruction_Cache;FFEC0000;FFECFFFF;1|LPD;R5_1_Data_Cache;FFED0000;FFEDFFFF;1|LPD;R5_1_BTCM_GLOBAL;FFEB0000;FFEBFFFF;1|LPD;R5_1_ATCM_GLOBAL;FFE90000;FFE9FFFF;1|LPD;R5_0_Instruction_Cache;FFE40000;FFE4FFFF;1|LPD;R5_0_Data_Cache;FFE50000;FFE5FFFF;1|LPD;R5_0_BTCM_GLOBAL;FFE20000;FFE2FFFF;1|LPD;R5_0_ATCM_GLOBAL;FFE00000;FFE0FFFF;1|LPD;QSPI_Linear_Address;C0000000;DFFFFFFF;1|LPD;QSPI;FF0F0000;FF0FFFFF;1|LPD;PMU_RAM;FFDC0000;FFDDFFFF;1|LPD;PMU_GLOBAL;FFD80000;FFDBFFFF;1|FPD;PCIE_MAIN;FD0E0000;FD0EFFFF;0|FPD;PCIE_LOW;E0000000;EFFFFFFF;0|FPD;PCIE_HIGH2;8000000000;BFFFFFFFFF;0|FPD;PCIE_HIGH1;600000000;7FFFFFFFF;0|FPD;PCIE_DMA;FD0F0000;FD0FFFFF;0|FPD;PCIE_ATTRIB;FD480000;FD48FFFF;0|LPD;OCM_XMPU_CFG;FFA70000;FFA7FFFF;1|LPD;OCM_SLCR;FF960000;FF96FFFF;1|OCM;OCM;FFFC0000;FFFFFFFF;1|LPD;NAND;FF100000;FF10FFFF;0|LPD;MBISTJTAG;FFCF0000;FFCFFFFF;1|LPD;LPD_XPPU_SINK;FF9C0000;FF9CFFFF;1|LPD;LPD_XPPU;FF980000;FF98FFFF;1|LPD;LPD_SLCR_SECURE;FF4B0000;FF4DFFFF;1|LPD;LPD_SLCR;FF410000;FF4AFFFF;1|LPD;LPD_GPV;FE100000;FE1FFFFF;1|LPD;LPD_DMA_7;FFAF0000;FFAFFFFF;1|LPD;LPD_DMA_6;FFAE0000;FFAEFFFF;1|LPD;LPD_DMA_5;FFAD0000;FFADFFFF;1|LPD;LPD_DMA_4;FFAC0000;FFACFFFF;1|LPD;LPD_DMA_3;FFAB0000;FFABFFFF;1|LPD;LPD_DMA_2;FFAA0000;FFAAFFFF;1|LPD;LPD_DMA_1;FFA90000;FFA9FFFF;1|LPD;LPD_DMA_0;FFA80000;FFA8FFFF;1|LPD;IPI_CTRL;FF380000;FF3FFFFF;1|LPD;IOU_SLCR;FF180000;FF23FFFF;1|LPD;IOU_SECURE_SLCR;FF240000;FF24FFFF;1|LPD;IOU_SCNTRS;FF260000;FF26FFFF;1|LPD;IOU_SCNTR;FF250000;FF25FFFF;1|LPD;IOU_GPV;FE000000;FE0FFFFF;1|LPD;I2C1;FF030000;FF03FFFF;1|LPD;I2C0;FF020000;FF02FFFF;0|FPD;GPU;FD4B0000;FD4BFFFF;1|LPD;GPIO;FF0A0000;FF0AFFFF;1|LPD;GEM3;FF0E0000;FF0EFFFF;0|LPD;GEM2;FF0D0000;FF0DFFFF;0|LPD;GEM1;FF0C0000;FF0CFFFF;0|LPD;GEM0;FF0B0000;FF0BFFFF;1|FPD;FPD_XMPU_SINK;FD4F0000;FD4FFFFF;1|FPD;FPD_XMPU_CFG;FD5D0000;FD5DFFFF;1|FPD;FPD_SLCR_SECURE;FD690000;FD6CFFFF;1|FPD;FPD_SLCR;FD610000;FD68FFFF;1|FPD;FPD_GPV;FD700000;FD7FFFFF;1|FPD;FPD_DMA_CH7;FD570000;FD57FFFF;1|FPD;FPD_DMA_CH6;FD560000;FD56FFFF;1|FPD;FPD_DMA_CH5;FD550000;FD55FFFF;1|FPD;FPD_DMA_CH4;FD540000;FD54FFFF;1|FPD;FPD_DMA_CH3;FD530000;FD53FFFF;1|FPD;FPD_DMA_CH2;FD520000;FD52FFFF;1|FPD;FPD_DMA_CH1;FD510000;FD51FFFF;1|FPD;FPD_DMA_CH0;FD500000;FD50FFFF;1|LPD;EFUSE;FFCC0000;FFCCFFFF;1|FPD;Display Port;FD4A0000;FD4AFFFF;0|FPD;DPDMA;FD4C0000;FD4CFFFF;0|FPD;DDR_XMPU5_CFG;FD050000;FD05FFFF;1|FPD;DDR_XMPU4_CFG;FD040000;FD04FFFF;1|FPD;DDR_XMPU3_CFG;FD030000;FD03FFFF;1|FPD;DDR_XMPU2_CFG;FD020000;FD02FFFF;1|FPD;DDR_XMPU1_CFG;FD010000;FD01FFFF;1|FPD;DDR_XMPU0_CFG;FD000000;FD00FFFF;1|FPD;DDR_QOS_CTRL;FD090000;FD09FFFF;1|FPD;DDR_PHY;FD080000;FD08FFFF;1|DDR;DDR_LOW;0;7FFFFFFF;1|DDR;DDR_HIGH;800000000;97FFFFFFF;1|FPD;DDDR_CTRL;FD070000;FD070FFF;1|LPD;Coresight;FE800000;FEFFFFFF;1|LPD;CSU_DMA;FFC80000;FFC9FFFF;1|LPD;CSU;FFCA0000;FFCAFFFF;0|LPD;CRL_APB;FF5E0000;FF85FFFF;1|FPD;CRF_APB;FD1A0000;FD2DFFFF;1|FPD;CCI_REG;FD5E0000;FD5EFFFF;1|FPD;CCI_GPV;FD6E0000;FD6EFFFF;1|LPD;CAN1;FF070000;FF07FFFF;0|LPD;CAN0;FF060000;FF06FFFF;0|FPD;APU;FD5C0000;FD5CFFFF;1|LPD;APM_INTC_IOU;FFA20000;FFA2FFFF;1|LPD;APM_FPD_LPD;FFA30000;FFA3FFFF;1|FPD;APM_5;FD490000;FD49FFFF;1|FPD;APM_0;FD0B0000;FD0BFFFF;1|LPD;APM2;FFA10000;FFA1FFFF;1|LPD;APM1;FFA00000;FFA0FFFF;1|LPD;AMS;FFA50000;FFA5FFFF;1|FPD;AFI_5;FD3B0000;FD3BFFFF;1|FPD;AFI_4;FD3A0000;FD3AFFFF;1|FPD;AFI_3;FD390000;FD39FFFF;1|FPD;AFI_2;FD380000;FD38FFFF;1|FPD;AFI_1;FD370000;FD37FFFF;1|FPD;AFI_0;FD360000;FD36FFFF;1|LPD;AFIFM6;FF9B0000;FF9BFFFF;1|FPD;ACPU_GIC;F9000000;F907FFFF;1} \
# #TE_MOD#    CONFIG.PSU__PROTECTION__MASTERS {USB1:NonSecure;1|USB0:NonSecure;1|S_AXI_LPD:NA;0|S_AXI_HPC1_FPD:NA;0|S_AXI_HPC0_FPD:NA;0|S_AXI_HP3_FPD:NA;0|S_AXI_HP2_FPD:NA;0|S_AXI_HP1_FPD:NA;0|S_AXI_HP0_FPD:NA;0|S_AXI_ACP:NA;0|S_AXI_ACE:NA;0|SD1:NonSecure;1|SD0:NonSecure;0|SATA1:NonSecure;0|SATA0:NonSecure;0|RPU1:Secure;1|RPU0:Secure;1|QSPI:NonSecure;1|PMU:NA;1|PCIe:NonSecure;0|NAND:NonSecure;0|LDMA:NonSecure;1|GPU:NonSecure;1|GEM3:NonSecure;0|GEM2:NonSecure;0|GEM1:NonSecure;0|GEM0:NonSecure;1|FDMA:NonSecure;1|DP:NonSecure;0|DAP:NA;1|Coresight:NA;1|CSU:NA;1|APU:NA;1} \
# #TE_MOD#    CONFIG.PSU__PL_CLK1_BUF {TRUE} \
# #TE_MOD#    CONFIG.PSU__PL_CLK0_BUF {TRUE} \
# #TE_MOD#    CONFIG.PSU__IOU_SLCR__WDT_CLK_SEL__SELECT {APB} \
# #TE_MOD#    CONFIG.PSU__IOU_SLCR__WDT0__FREQMHZ {99.999992} \
# #TE_MOD#    CONFIG.PSU__IOU_SLCR__WDT0__ACT_FREQMHZ {99.999992} \
# #TE_MOD#    CONFIG.PSU__IOU_SLCR__TTC3__FREQMHZ {100.000000} \
# #TE_MOD#    CONFIG.PSU__IOU_SLCR__TTC3__ACT_FREQMHZ {100.000000} \
# #TE_MOD#    CONFIG.PSU__IOU_SLCR__TTC2__FREQMHZ {100.000000} \
# #TE_MOD#    CONFIG.PSU__IOU_SLCR__TTC2__ACT_FREQMHZ {100.000000} \
# #TE_MOD#    CONFIG.PSU__IOU_SLCR__TTC1__FREQMHZ {100.000000} \
# #TE_MOD#    CONFIG.PSU__IOU_SLCR__TTC1__ACT_FREQMHZ {100.000000} \
# #TE_MOD#    CONFIG.PSU__IOU_SLCR__TTC0__FREQMHZ {100.000000} \
# #TE_MOD#    CONFIG.PSU__IOU_SLCR__TTC0__ACT_FREQMHZ {100.000000} \
# #TE_MOD#    CONFIG.PSU__I2C1__PERIPHERAL__IO {MIO 20 .. 21} \
# #TE_MOD#    CONFIG.PSU__I2C1__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__GPIO1_MIO__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__GPIO1_MIO__IO {MIO 26 .. 51} \
# #TE_MOD#    CONFIG.PSU__GPIO0_MIO__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__GPIO0_MIO__IO {MIO 0 .. 25} \
# #TE_MOD#    CONFIG.PSU__GEM__TSU__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__GEM0_COHERENCY {0} \
# #TE_MOD#    CONFIG.PSU__FPGA_PL1_ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__FPGA_PL0_ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__FPD_SLCR__WDT_CLK_SEL__SELECT {APB} \
# #TE_MOD#    CONFIG.PSU__FPD_SLCR__WDT1__FREQMHZ {99.999992} \
# #TE_MOD#    CONFIG.PSU__FPD_SLCR__WDT1__ACT_FREQMHZ {99.999992} \
# #TE_MOD#    CONFIG.PSU__ENET0__TSU__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__ENET0__PTP__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__ENET0__PERIPHERAL__IO {MIO 26 .. 37} \
# #TE_MOD#    CONFIG.PSU__ENET0__PERIPHERAL__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__ENET0__GRP_MDIO__IO {MIO 76 .. 77} \
# #TE_MOD#    CONFIG.PSU__ENET0__GRP_MDIO__ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__ENET0__FIFO__ENABLE {0} \
# #TE_MOD#    CONFIG.PSU__DLL__ISUSED {1} \
# #TE_MOD#    CONFIG.PSU__DDR__INTERFACE__FREQMHZ {600.000} \
# #TE_MOD#    CONFIG.PSU__DDR_HIGH_ADDRESS_GUI_ENABLE {1} \
# #TE_MOD#    CONFIG.PSU__DDRC__T_RP {17} \
# #TE_MOD#    CONFIG.PSU__DDRC__T_RCD {17} \
# #TE_MOD#    CONFIG.PSU__DDRC__T_RC {46.16} \
# #TE_MOD#    CONFIG.PSU__DDRC__T_RAS_MIN {32.0} \
# #TE_MOD#    CONFIG.PSU__DDRC__T_FAW {30.0} \
# #TE_MOD#    CONFIG.PSU__DDRC__SPEED_BIN {DDR4_2400T} \
# #TE_MOD#    CONFIG.PSU__DDRC__ROW_ADDR_COUNT {16} \
# #TE_MOD#    CONFIG.PSU__DDRC__FGRM {1X} \
# #TE_MOD#    CONFIG.PSU__DDRC__DRAM_WIDTH {8 Bits} \
# #TE_MOD#    CONFIG.PSU__DDRC__DEVICE_CAPACITY {8192 MBits} \
# #TE_MOD#    CONFIG.PSU__DDRC__DDR4_T_REF_MODE {1} \
# #TE_MOD#    CONFIG.PSU__DDRC__CWL {12} \
# #TE_MOD#    CONFIG.PSU__DDRC__COMPONENTS {UDIMM} \
# #TE_MOD#    CONFIG.PSU__DDRC__CL {17} \
# #TE_MOD#    CONFIG.PSU__DDRC__BG_ADDR_COUNT {2} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__USB3_DUAL_REF_CTRL__DIVISOR1 {15} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__USB3_DUAL_REF_CTRL__DIVISOR0 {5} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__USB1_BUS_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__USB1_BUS_REF_CTRL__DIVISOR0 {6} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__USB1_BUS_REF_CTRL__ACT_FREQMHZ {249.999975} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__USB0_BUS_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__USB0_BUS_REF_CTRL__DIVISOR0 {6} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__USB0_BUS_REF_CTRL__ACT_FREQMHZ {249.999975} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__UART1_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__UART1_REF_CTRL__DIVISOR0 {15} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__UART0_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__UART0_REF_CTRL__DIVISOR0 {15} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__UART0_REF_CTRL__ACT_FREQMHZ {99.999990} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__TIMESTAMP_REF_CTRL__DIVISOR0 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__TIMESTAMP_REF_CTRL__ACT_FREQMHZ {33.333330} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__SPI1_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__SPI1_REF_CTRL__DIVISOR0 {7} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__SPI0_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__SPI0_REF_CTRL__DIVISOR0 {7} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__SDIO1_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__SDIO1_REF_CTRL__DIVISOR0 {4} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__SDIO1_REF_CTRL__ACT_FREQMHZ {199.999980} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__SDIO0_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__SDIO0_REF_CTRL__DIVISOR0 {7} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__RPLL_TO_FPD_CTRL__DIVISOR0 {2} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__RPLL_CTRL__FRACDATA {0.000000} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__RPLL_CTRL__FBDIV {48} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__RPLL_CTRL__DIV2 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__QSPI_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__QSPI_REF_CTRL__DIVISOR0 {5} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__QSPI_REF_CTRL__ACT_FREQMHZ {299.999970} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PL3_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PL3_REF_CTRL__DIVISOR0 {4} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PL2_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PL2_REF_CTRL__DIVISOR0 {4} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PL1_REF_CTRL__SRCSEL {RPLL} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PL1_REF_CTRL__FREQMHZ {25} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PL1_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PL1_REF_CTRL__DIVISOR0 {32} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PL1_REF_CTRL__ACT_FREQMHZ {24.999997} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PL0_REF_CTRL__FREQMHZ {100} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PL0_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PL0_REF_CTRL__DIVISOR0 {8} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PL0_REF_CTRL__ACT_FREQMHZ {99.999990} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PCAP_CTRL__DIVISOR0 {8} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__PCAP_CTRL__ACT_FREQMHZ {187.499981} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__NAND_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__NAND_REF_CTRL__DIVISOR0 {15} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__LPD_SWITCH_CTRL__DIVISOR0 {3} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__LPD_SWITCH_CTRL__ACT_FREQMHZ {499.999950} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__LPD_LSBUS_CTRL__DIVISOR0 {15} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__LPD_LSBUS_CTRL__ACT_FREQMHZ {99.999990} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__IOU_SWITCH_CTRL__DIVISOR0 {3} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__IOU_SWITCH_CTRL__ACT_FREQMHZ {266.666640} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__IOPLL_TO_FPD_CTRL__DIVISOR0 {3} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__IOPLL_CTRL__FRACDATA {0.000000} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__IOPLL_CTRL__FBDIV {90} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__IOPLL_CTRL__DIV2 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__I2C1_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__I2C1_REF_CTRL__DIVISOR0 {15} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__I2C1_REF_CTRL__ACT_FREQMHZ {99.999990} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__I2C0_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__I2C0_REF_CTRL__DIVISOR0 {15} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__GEM_TSU_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__GEM_TSU_REF_CTRL__DIVISOR0 {6} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__GEM_TSU_REF_CTRL__ACT_FREQMHZ {249.999975} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__GEM3_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__GEM3_REF_CTRL__DIVISOR0 {12} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__GEM2_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__GEM2_REF_CTRL__DIVISOR0 {12} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__GEM1_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__GEM1_REF_CTRL__DIVISOR0 {12} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__GEM0_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__GEM0_REF_CTRL__DIVISOR0 {12} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__GEM0_REF_CTRL__ACT_FREQMHZ {124.999988} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__DLL_REF_CTRL__ACT_FREQMHZ {1499.999850} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__DBG_LPD_CTRL__DIVISOR0 {6} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__DBG_LPD_CTRL__ACT_FREQMHZ {249.999975} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__CPU_R5_CTRL__DIVISOR0 {3} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__CPU_R5_CTRL__ACT_FREQMHZ {499.999950} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__CAN1_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__CAN1_REF_CTRL__DIVISOR0 {15} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__CAN0_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__CAN0_REF_CTRL__DIVISOR0 {15} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__AMS_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__AMS_REF_CTRL__DIVISOR0 {30} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__AMS_REF_CTRL__ACT_FREQMHZ {49.999995} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__AFI6_REF_CTRL__DIVISOR0 {3} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__ADMA_REF_CTRL__DIVISOR0 {3} \
# #TE_MOD#    CONFIG.PSU__CRL_APB__ADMA_REF_CTRL__ACT_FREQMHZ {499.999950} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__VPLL_TO_LPD_CTRL__DIVISOR0 {2} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__VPLL_CTRL__FRACDATA {0.000000} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__VPLL_CTRL__FBDIV {63} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__VPLL_CTRL__DIV2 {1} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__TOPSW_MAIN_CTRL__DIVISOR0 {2} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__TOPSW_MAIN_CTRL__ACT_FREQMHZ {524.999947} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__TOPSW_LSBUS_CTRL__DIVISOR0 {5} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__TOPSW_LSBUS_CTRL__ACT_FREQMHZ {99.999990} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__SATA_REF_CTRL__DIVISOR0 {5} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__PCIE_REF_CTRL__DIVISOR0 {6} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__GPU_REF_CTRL__DIVISOR0 {2} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__GPU_REF_CTRL__ACT_FREQMHZ {599.999940} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__GDMA_REF_CTRL__DIVISOR0 {2} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__GDMA_REF_CTRL__ACT_FREQMHZ {599.999940} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DP_VIDEO_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DP_VIDEO_REF_CTRL__DIVISOR0 {5} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DP_STC_REF_CTRL__DIVISOR1 {10} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DP_STC_REF_CTRL__DIVISOR0 {6} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DP_AUDIO_REF_CTRL__DIVISOR1 {1} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DP_AUDIO_REF_CTRL__DIVISOR0 {63} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DPLL_TO_LPD_CTRL__DIVISOR0 {3} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DPLL_CTRL__FRACDATA {0.000000} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DPLL_CTRL__FBDIV {72} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DPLL_CTRL__DIV2 {1} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DPDMA_REF_CTRL__DIVISOR0 {2} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DPDMA_REF_CTRL__ACT_FREQMHZ {599.999940} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DDR_CTRL__FREQMHZ {1200} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DDR_CTRL__DIVISOR0 {2} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DDR_CTRL__ACT_FREQMHZ {599.999940} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DBG_TSTMP_CTRL__DIVISOR0 {2} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DBG_TSTMP_CTRL__ACT_FREQMHZ {249.999975} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DBG_TRACE_CTRL__DIVISOR0 {5} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DBG_FPD_CTRL__DIVISOR0 {2} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__DBG_FPD_CTRL__ACT_FREQMHZ {249.999975} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__APLL_TO_LPD_CTRL__DIVISOR0 {3} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__APLL_CTRL__FRACDATA {0.000000} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__APLL_CTRL__FBDIV {72} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__APLL_CTRL__DIV2 {1} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__ACPU_CTRL__DIVISOR0 {1} \
# #TE_MOD#    CONFIG.PSU__CRF_APB__ACPU_CTRL__ACT_FREQMHZ {1199.999880} \
# #TE_MOD#    CONFIG.PSU__ACT_DDR_FREQ_MHZ {1199.999878} \
# #TE_MOD#    CONFIG.PSU_SD1_INTERNAL_BUS_WIDTH {4} \
# #TE_MOD#    CONFIG.PSU_MIO_TREE_SIGNALS {sclk_out#miso_mo1#mo2#mo3#mosi_mi0#n_ss_out#clk_for_lpbk#n_ss_out_upper#mo_upper[0]#mo_upper[1]#mo_upper[2]#mo_upper[3]#sclk_out_upper#gpio0[13]#gpio0[14]#gpio0[15]#gpio0[16]#gpio0[17]#gpio0[18]#gpio0[19]#scl_out#sda_out#rxd#txd#gpio0[24]#gpio0[25]#rgmii_tx_clk#rgmii_txd[0]#rgmii_txd[1]#rgmii_txd[2]#rgmii_txd[3]#rgmii_tx_ctl#rgmii_rx_clk#rgmii_rxd[0]#rgmii_rxd[1]#rgmii_rxd[2]#rgmii_rxd[3]#rgmii_rx_ctl#gpio1[38]#gpio1[39]#gpio1[40]#gpio1[41]#gpio1[42]#gpio1[43]#gpio1[44]#sdio1_cd_n#sdio1_data_out[0]#sdio1_data_out[1]#sdio1_data_out[2]#sdio1_data_out[3]#sdio1_cmd_out#sdio1_clk_out#ulpi_clk_in#ulpi_dir#ulpi_tx_data[2]#ulpi_nxt#ulpi_tx_data[0]#ulpi_tx_data[1]#ulpi_stp#ulpi_tx_data[3]#ulpi_tx_data[4]#ulpi_tx_data[5]#ulpi_tx_data[6]#ulpi_tx_data[7]#ulpi_clk_in#ulpi_dir#ulpi_tx_data[2]#ulpi_nxt#ulpi_tx_data[0]#ulpi_tx_data[1]#ulpi_stp#ulpi_tx_data[3]#ulpi_tx_data[4]#ulpi_tx_data[5]#ulpi_tx_data[6]#ulpi_tx_data[7]#gem0_mdc#gem0_mdio_out} \
# #TE_MOD#    CONFIG.PSU_MIO_TREE_PERIPHERALS {Quad SPI Flash#Quad SPI Flash#Quad SPI Flash#Quad SPI Flash#Quad SPI Flash#Quad SPI Flash#Feedback Clk#Quad SPI Flash#Quad SPI Flash#Quad SPI Flash#Quad SPI Flash#Quad SPI Flash#Quad SPI Flash#GPIO0 MIO#GPIO0 MIO#GPIO0 MIO#GPIO0 MIO#GPIO0 MIO#GPIO0 MIO#GPIO0 MIO#I2C 1#I2C 1#UART 0#UART 0#GPIO0 MIO#GPIO0 MIO#Gem 0#Gem 0#Gem 0#Gem 0#Gem 0#Gem 0#Gem 0#Gem 0#Gem 0#Gem 0#Gem 0#Gem 0#GPIO1 MIO#GPIO1 MIO#GPIO1 MIO#GPIO1 MIO#GPIO1 MIO#GPIO1 MIO#GPIO1 MIO#SD 1#SD 1#SD 1#SD 1#SD 1#SD 1#SD 1#USB 0#USB 0#USB 0#USB 0#USB 0#USB 0#USB 0#USB 0#USB 0#USB 0#USB 0#USB 0#USB 1#USB 1#USB 1#USB 1#USB 1#USB 1#USB 1#USB 1#USB 1#USB 1#USB 1#USB 1#MDIO 0#MDIO 0} \
# #TE_MOD#    CONFIG.PSU_MIO_9_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_8_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_7_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_7_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_77_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_76_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_76_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_75_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_74_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_73_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_72_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_71_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_70_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_70_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_6_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_6_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_69_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_68_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_67_SLEW {slow} \
# #TE_MOD#    CONFIG.PSU_MIO_67_DRIVE_STRENGTH {12} \
# #TE_MOD#    CONFIG.PSU_MIO_67_DIRECTION {in} \
# #TE_MOD#    CONFIG.PSU_MIO_66_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_65_SLEW {slow} \
# #TE_MOD#    CONFIG.PSU_MIO_65_DRIVE_STRENGTH {12} \
# #TE_MOD#    CONFIG.PSU_MIO_65_DIRECTION {in} \
# #TE_MOD#    CONFIG.PSU_MIO_64_SLEW {slow} \
# #TE_MOD#    CONFIG.PSU_MIO_64_DRIVE_STRENGTH {12} \
# #TE_MOD#    CONFIG.PSU_MIO_64_DIRECTION {in} \
# #TE_MOD#    CONFIG.PSU_MIO_63_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_62_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_61_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_60_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_5_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_5_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_59_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_58_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_58_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_57_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_56_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_55_SLEW {slow} \
# #TE_MOD#    CONFIG.PSU_MIO_55_DRIVE_STRENGTH {12} \
# #TE_MOD#    CONFIG.PSU_MIO_55_DIRECTION {in} \
# #TE_MOD#    CONFIG.PSU_MIO_54_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_53_SLEW {slow} \
# #TE_MOD#    CONFIG.PSU_MIO_53_DRIVE_STRENGTH {12} \
# #TE_MOD#    CONFIG.PSU_MIO_53_DIRECTION {in} \
# #TE_MOD#    CONFIG.PSU_MIO_52_SLEW {slow} \
# #TE_MOD#    CONFIG.PSU_MIO_52_DRIVE_STRENGTH {12} \
# #TE_MOD#    CONFIG.PSU_MIO_52_DIRECTION {in} \
# #TE_MOD#    CONFIG.PSU_MIO_51_PULLUPDOWN {disable} \
# #TE_MOD#    CONFIG.PSU_MIO_51_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_51_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_50_PULLUPDOWN {disable} \
# #TE_MOD#    CONFIG.PSU_MIO_50_INPUT_TYPE {cmos} \
# #TE_MOD#    CONFIG.PSU_MIO_50_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_4_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_49_PULLUPDOWN {disable} \
# #TE_MOD#    CONFIG.PSU_MIO_49_INPUT_TYPE {cmos} \
# #TE_MOD#    CONFIG.PSU_MIO_49_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_48_PULLUPDOWN {disable} \
# #TE_MOD#    CONFIG.PSU_MIO_48_INPUT_TYPE {cmos} \
# #TE_MOD#    CONFIG.PSU_MIO_48_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_47_PULLUPDOWN {disable} \
# #TE_MOD#    CONFIG.PSU_MIO_47_INPUT_TYPE {cmos} \
# #TE_MOD#    CONFIG.PSU_MIO_47_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_46_PULLUPDOWN {disable} \
# #TE_MOD#    CONFIG.PSU_MIO_46_INPUT_TYPE {cmos} \
# #TE_MOD#    CONFIG.PSU_MIO_46_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_45_SLEW {slow} \
# #TE_MOD#    CONFIG.PSU_MIO_45_PULLUPDOWN {disable} \
# #TE_MOD#    CONFIG.PSU_MIO_45_INPUT_TYPE {cmos} \
# #TE_MOD#    CONFIG.PSU_MIO_45_DRIVE_STRENGTH {12} \
# #TE_MOD#    CONFIG.PSU_MIO_45_DIRECTION {in} \
# #TE_MOD#    CONFIG.PSU_MIO_44_PULLUPDOWN {disable} \
# #TE_MOD#    CONFIG.PSU_MIO_44_INPUT_TYPE {cmos} \
# #TE_MOD#    CONFIG.PSU_MIO_44_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_43_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_42_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_41_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_40_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_3_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_39_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_38_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_37_SLEW {slow} \
# #TE_MOD#    CONFIG.PSU_MIO_37_DRIVE_STRENGTH {12} \
# #TE_MOD#    CONFIG.PSU_MIO_37_DIRECTION {in} \
# #TE_MOD#    CONFIG.PSU_MIO_36_SLEW {slow} \
# #TE_MOD#    CONFIG.PSU_MIO_36_DRIVE_STRENGTH {12} \
# #TE_MOD#    CONFIG.PSU_MIO_36_DIRECTION {in} \
# #TE_MOD#    CONFIG.PSU_MIO_35_SLEW {slow} \
# #TE_MOD#    CONFIG.PSU_MIO_35_DRIVE_STRENGTH {12} \
# #TE_MOD#    CONFIG.PSU_MIO_35_DIRECTION {in} \
# #TE_MOD#    CONFIG.PSU_MIO_34_SLEW {slow} \
# #TE_MOD#    CONFIG.PSU_MIO_34_DRIVE_STRENGTH {12} \
# #TE_MOD#    CONFIG.PSU_MIO_34_DIRECTION {in} \
# #TE_MOD#    CONFIG.PSU_MIO_33_SLEW {slow} \
# #TE_MOD#    CONFIG.PSU_MIO_33_DRIVE_STRENGTH {12} \
# #TE_MOD#    CONFIG.PSU_MIO_33_DIRECTION {in} \
# #TE_MOD#    CONFIG.PSU_MIO_32_SLEW {slow} \
# #TE_MOD#    CONFIG.PSU_MIO_32_DRIVE_STRENGTH {12} \
# #TE_MOD#    CONFIG.PSU_MIO_32_DIRECTION {in} \
# #TE_MOD#    CONFIG.PSU_MIO_31_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_31_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_30_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_30_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_2_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_29_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_29_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_28_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_28_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_27_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_27_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_26_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_26_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_25_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_24_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_23_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_23_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_22_SLEW {slow} \
# #TE_MOD#    CONFIG.PSU_MIO_22_DRIVE_STRENGTH {12} \
# #TE_MOD#    CONFIG.PSU_MIO_22_DIRECTION {in} \
# #TE_MOD#    CONFIG.PSU_MIO_21_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_20_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_1_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_19_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_18_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_17_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_16_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_15_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_14_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_13_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_12_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_12_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_MIO_11_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_10_DIRECTION {inout} \
# #TE_MOD#    CONFIG.PSU_MIO_0_INPUT_TYPE {schmitt} \
# #TE_MOD#    CONFIG.PSU_MIO_0_DIRECTION {out} \
# #TE_MOD#    CONFIG.PSU_DDR_RAM_LOWADDR_OFFSET {0x80000000} \
# #TE_MOD#    CONFIG.PSU_DDR_RAM_HIGHADDR_OFFSET {0x800000000} \
# #TE_MOD#    CONFIG.PSU_DDR_RAM_HIGHADDR {0x1FFFFFFFF} \
# #TE_MOD#    CONFIG.PSU_BANK_3_IO_STANDARD {LVCMOS18} \
# #TE_MOD#    CONFIG.PSU_BANK_2_IO_STANDARD {LVCMOS18} \
# #TE_MOD#    CONFIG.PSU_BANK_1_IO_STANDARD {LVCMOS18} \
# #TE_MOD#    CONFIG.PSU_BANK_0_IO_STANDARD {LVCMOS18} \
# #TE_MOD# #Empty Line
  # Create interface connections
  connect_bd_intf_net -intf_net CLK_IN_D_0_1 [get_bd_intf_ports CLK2] [get_bd_intf_pins util_ds_buf_0/CLK_IN_D]
  connect_bd_intf_net -intf_net CLK_IN_D_0_2 [get_bd_intf_ports TEST_CLK] [get_bd_intf_pins util_ds_buf_2/CLK_IN_D]
  connect_bd_intf_net -intf_net GT_DIFF_REFCLK1_0_1 [get_bd_intf_ports CLK4] [get_bd_intf_pins GT_system/GT_DIFF_REFCLK2]
  connect_bd_intf_net -intf_net GT_DIFF_REFCLK1_1_1 [get_bd_intf_ports CLK1] [get_bd_intf_pins GT_system/GT_DIFF_REFCLK1]
  connect_bd_intf_net -intf_net GT_SERIAL_RX_0_1 [get_bd_intf_ports GT_PE4_RX] [get_bd_intf_pins GT_system/GT_PE4_RX]
  connect_bd_intf_net -intf_net GT_SERIAL_RX_1_1 [get_bd_intf_ports GT_PE3_RX] [get_bd_intf_pins GT_system/GT_PE3_RX]
  connect_bd_intf_net -intf_net GT_SERIAL_RX_2_1 [get_bd_intf_ports GT_PE5_RX] [get_bd_intf_pins GT_system/GT_PE5_RX]
  connect_bd_intf_net -intf_net GT_SERIAL_RX_3_1 [get_bd_intf_ports GT_PE6_RX] [get_bd_intf_pins GT_system/GT_PE6_RX]
  connect_bd_intf_net -intf_net GT_SERIAL_RX_4_1 [get_bd_intf_ports GT_PE8_RX] [get_bd_intf_pins GT_system/GT_PE8_RX]
  connect_bd_intf_net -intf_net GT_SERIAL_RX_5_1 [get_bd_intf_ports GT_PE7_RX] [get_bd_intf_pins GT_system/GT_PE7_RX]
  connect_bd_intf_net -intf_net GT_system_GT_SERIAL_TX_0 [get_bd_intf_ports GT_PE4_TX] [get_bd_intf_pins GT_system/GT_PE4_TX]
  connect_bd_intf_net -intf_net GT_system_GT_SERIAL_TX_1 [get_bd_intf_ports GT_PE3_TX] [get_bd_intf_pins GT_system/GT_PE3_TX]
  connect_bd_intf_net -intf_net GT_system_GT_SERIAL_TX_2 [get_bd_intf_ports GT_PE5_TX] [get_bd_intf_pins GT_system/GT_PE5_TX]
  connect_bd_intf_net -intf_net GT_system_GT_SERIAL_TX_3 [get_bd_intf_ports GT_PE6_TX] [get_bd_intf_pins GT_system/GT_PE6_TX]
  connect_bd_intf_net -intf_net GT_system_GT_SERIAL_TX_4 [get_bd_intf_ports GT_PE8_TX] [get_bd_intf_pins GT_system/GT_PE8_TX]
  connect_bd_intf_net -intf_net GT_system_GT_SERIAL_TX_5 [get_bd_intf_ports GT_PE7_TX] [get_bd_intf_pins GT_system/GT_PE7_TX]
  connect_bd_intf_net -intf_net axis_data_fifo_0_M_AXIS [get_bd_intf_pins axis_data_fifo_0/M_AXIS] [get_bd_intf_pins ft601_if_0/s_axis]
  connect_bd_intf_net -intf_net ft601_if_0_m_axis [get_bd_intf_pins axis_data_fifo_0/S_AXIS] [get_bd_intf_pins ft601_if_0/m_axis]

  # Create port connections
  connect_bd_net -net CLK2_fmeter [get_bd_pins labtools_fmeter_0/F0] [get_bd_pins vio_0/probe_in0]
  connect_bd_net -net GT_system_pe4_usr_clk [get_bd_pins GT_system/pe4_usr_clk] [get_bd_pins xlconcat_0/In2]
  connect_bd_net -net GT_system_pe7_usr_clk [get_bd_pins GT_system/pe7_usr_clk] [get_bd_pins xlconcat_0/In3]
  connect_bd_net -net MGT_channel_up [get_bd_pins GT_system/channel_up] [get_bd_pins vio_0/probe_in2]
  connect_bd_net -net MGT_pll_locked [get_bd_pins GT_system/dout] [get_bd_pins vio_0/probe_in6]
  connect_bd_net -net Net [get_bd_ports DATA] [get_bd_pins ft601_if_0/data_io]
  connect_bd_net -net Net1 [get_bd_ports BE] [get_bd_pins ft601_if_0/be_io]
  connect_bd_net -net PE4_fmeter [get_bd_pins labtools_fmeter_0/F2] [get_bd_pins vio_0/probe_in3]
  connect_bd_net -net PE7_fmeter [get_bd_pins labtools_fmeter_0/F3] [get_bd_pins vio_0/probe_in4]
  connect_bd_net -net USB_fmeter [get_bd_pins labtools_fmeter_0/F1] [get_bd_pins vio_0/probe_in1]
  connect_bd_net -net clk_in_0_1 [get_bd_ports FIFO_CLK] [get_bd_pins ft601_if_0/clk_in]
  connect_bd_net -net ft601_if_0_axis_aclk [get_bd_pins axis_data_fifo_0/s_axis_aclk] [get_bd_pins ft601_if_0/axis_aclk] [get_bd_pins proc_sys_reset_0/slowest_sync_clk] [get_bd_pins xlconcat_0/In1]
  connect_bd_net -net ft601_if_0_oe_n_out [get_bd_ports OE_N] [get_bd_pins ft601_if_0/oe_n_out]
  connect_bd_net -net ft601_if_0_rd_n_out [get_bd_ports RD_N] [get_bd_pins ft601_if_0/rd_n_out]
  connect_bd_net -net ft601_if_0_reset_n_out [get_bd_ports FTDI_RESET_N] [get_bd_pins ft601_if_0/reset_n_out]
  connect_bd_net -net ft601_if_0_siwu_n_out [get_bd_ports SIWU_N] [get_bd_pins ft601_if_0/siwu_n_out]
  connect_bd_net -net ft601_if_0_wakeup_n_out [get_bd_ports WAKEUP_N] [get_bd_pins ft601_if_0/wakeup_n_out]
  connect_bd_net -net ft601_if_0_wr_n_out [get_bd_ports WR_N] [get_bd_pins ft601_if_0/wr_n_out]
  connect_bd_net -net gt_loopback [get_bd_pins GT_system/loopback] [get_bd_pins vio_0/probe_out1]
  connect_bd_net -net gt_pma_init [get_bd_pins GT_system/pma_init] [get_bd_pins vio_0/probe_out4]
  connect_bd_net -net gt_power_down [get_bd_pins GT_system/power_down] [get_bd_pins vio_0/probe_out2]
  connect_bd_net -net gt_reset_pb [get_bd_pins GT_system/reset_pb] [get_bd_pins vio_0/probe_out3]
  connect_bd_net -net gt_rxcdrovrden [get_bd_pins GT_system/gt_rxcdrovrden_in] [get_bd_pins vio_0/probe_out0]
  connect_bd_net -net proc_sys_reset_0_peripheral_aresetn [get_bd_pins axis_data_fifo_0/s_axis_aresetn] [get_bd_pins proc_sys_reset_0/peripheral_aresetn]
  connect_bd_net -net reset_in_1 [get_bd_pins GT_system/reset_in] [get_bd_pins proc_sys_reset_0/ext_reset_in] [get_bd_pins zynq_ultra_ps_e_0/pl_resetn0]
  connect_bd_net -net rxf_n_in_0_1 [get_bd_ports RXF_N] [get_bd_pins ft601_if_0/rxf_n_in]
  connect_bd_net -net test_fmeter [get_bd_pins labtools_fmeter_0/F4] [get_bd_pins vio_0/probe_in5]
  connect_bd_net -net txe_n_in_0_1 [get_bd_ports TXE_N] [get_bd_pins ft601_if_0/txe_n_in]
  connect_bd_net -net util_ds_buf_0_IBUF_OUT [get_bd_pins util_ds_buf_0/IBUF_OUT] [get_bd_pins util_ds_buf_1/BUFG_I]
  connect_bd_net -net util_ds_buf_1_BUFG_O [get_bd_pins util_ds_buf_1/BUFG_O] [get_bd_pins xlconcat_0/In0]
  connect_bd_net -net util_ds_buf_2_IBUF_OUT [get_bd_pins util_ds_buf_2/IBUF_OUT] [get_bd_pins xlconcat_0/In4]
  connect_bd_net -net vio_LED_FP [get_bd_ports LED_FP] [get_bd_pins vio_0/probe_out5]
  connect_bd_net -net xlconcat_0_dout [get_bd_pins labtools_fmeter_0/fin] [get_bd_pins xlconcat_0/dout]
  connect_bd_net -net zynq_ultra_ps_e_0_pl_clk0 [get_bd_pins labtools_fmeter_0/refclk] [get_bd_pins vio_0/clk] [get_bd_pins zynq_ultra_ps_e_0/maxihpm0_lpd_aclk] [get_bd_pins zynq_ultra_ps_e_0/pl_clk0]
  connect_bd_net -net zynq_ultra_ps_e_0_pl_clk1 [get_bd_pins GT_system/init_clk] [get_bd_pins zynq_ultra_ps_e_0/pl_clk1]

  # Create address segments


  # Restore current instance
  current_bd_instance $oldCurInst

  save_bd_design
}
# End of create_root_design()


##################################################################
# MAIN FLOW
##################################################################

create_root_design ""



